(in-package #:odo/model-api)

(defsection @odo/model-api/constraint (:title "Constraints")
  "Odo provides an interface for constraints, which are named predicates that
must be satisfied by the assignments to variables. Constraints must respond to
the predicate interface functions as well as the following functions.

#### Types ####"
  (odo:constraint class)
  (odo:odo-constraint class)
  (odo:contingent-constraint class)
  (odo:odo-contingent-constraint class)
  (odo:constraint-p generic-function)
  (odo:odo-constraint-p generic-function)
  "#### Constructors ####"
  (odo:make-constraint function)
  (odo:make-guarded-constraint function)
  "#### Conditions ####"
  (odo:constraint-error condition)
  "#### Properties ####

In addition to the `@ODO/MODEL-API/ANNOTATION` API, constraints can be
queried for their name."
  (odo:constraint-name generic-function)
  (odo:expression generic-function)
  (odo:constraint-expression generic-function))


;;; Conditions

(define-condition odo:constraint-error ()
  ())

(define-condition simple-constraint-error (odo:constraint-error simple-error)
  ())

(defun raise-constraint-error (format-control &rest format-args)
  (error 'simple-constraint-error
         :format-control format-control
         :format-arguments format-args))


;;; Types

(defclass odo:constraint (odo:object)
  ()
  (:documentation
   "A constraint. Could be of the normal variety or could be
a contingent constraint."))

(utils:define-renamed-class odo:odo-constraint odo:constraint)

(defclass odo:contingent-constraint (odo:constraint)
  ()
  (:documentation "A constraint on Nature. A contingent constraint
must be scoped over at least one uncontrollable variable. In a planning
context, Nature will assign such variable(s) during execution in a way
that satisfies the constraint."))

(utils:define-renamed-class odo:odo-contingent-constraint odo:contingent-constraint)

(defgeneric odo:constraint-p (obj)
  (:documentation "Returns T iff `OBJ` is an Odo constraint.")
  (:method ((obj t))
    nil))

(utils:define-renamed-generic (odo:odo-constraint-p odo:constraint-p) (obj))


;;; Constructor

(defun odo:make-constraint (predicate
                            &key
                              name
                              contingent-p
                              annotations
                            &allow-other-keys)
  "Instantiate and return a new constraint.

`PREDICATE` Must be an instance of an `ODO-APPLICATION-EXPRESSION`.

If `NAME` is not supplied, a name is autogenerated."
  (unless (or (odo:variable-p predicate)
              (odo:conditional-variable-p predicate))
    (check-contingent-restrictions predicate contingent-p))
  (odo:make-instance 'odo:constraint
                     :expression predicate
                     :name (or name (gensym (uiop:standard-case-symbol-name 'c)))
                     :contingent-p contingent-p
                     :annotations annotations))

(defun odo:make-guarded-constraint (guard-predicate
                                    predicate
                                    &key
                                      name
                                      contingent-p
                                      annotations)
  "Instantiate and return a new constraint where `PREDICATE` is enforced to be
true if `GUARD-PREDICATE` is true."
  (odo:make-constraint (odo:-> guard-predicate predicate)
                       :name name
                       :contingent-p contingent-p
                       :annotations annotations))


;;; Checks for restrictions on contingent constraints

;;; Only the following predicates may be used in contingent constraints:
;;;   simple-temporal         [may be contingent or regular]
;;;   probabilistic-duration  [must be contingent]
;;; As both of these are temporal constraints, their to-events must be
;;; uncontrollable variables.

(defun check-contingent-restrictions (predicate
                                      contingent-p)
  ;; determine type of predicate
  ;;   error if unrecognizable
  ;; if simple-temporal and contingent, check to-event uncontrollable
  ;; if probabilistic-duration, check contingent and to-event uncontrollable
  (cond
    ((typep (odo:type predicate) 'odo:uncontrollable-variable)
     contingent-p)
    ((typep (odo:type predicate) 'odo:variable)
     (not contingent-p))
    (t
     (case (odo:operator predicate)
       (odo:simple-temporal
        (when contingent-p
          (check-to-event-is-uncontrollable predicate)))
       (odo:probabilistic-duration
        (unless contingent-p
          (raise-constraint-error
           "Probabilistic duration constraints must be contingent."))
        (check-to-event-is-uncontrollable predicate))
       (odo:->
        (when contingent-p
          (check-contingent-restrictions (odo:argument-value predicate 'odo:right)
                                         contingent-p)))
       (otherwise
        (when contingent-p
          (raise-constraint-error
           "Contingent constraints do not support ~s predicates."
           (odo:operator predicate))))))))

(defun check-to-event-is-uncontrollable (predicate)
  (let ((to-event (odo:argument-value predicate 'odo:to)))
    (unless (typep (odo:type to-event)
                   'odo:uncontrollable-variable)
      (raise-constraint-error
       "Contingent temporal constraints must terminate on uncontrollable ~
        event variables. Variable ~s is not uncontrollable."
       to-event))))


;;; API

(utils:define-renamed-generic (odo:constraint-name odo:name) (constraint))

(defgeneric odo:expression (constraint)
  (:documentation "Return the predicate of the constraint."))

(utils:define-renamed-generic (odo:constraint-expression odo:expression :redirect t) (constraint))

(defmethod odo:equal-p-by-type (left right (left-type odo:constraint) (right-type odo:constraint))
  (and
   (eq left-type right-type)
   (equal (odo:name left)
          (odo:name right))
   (utils:plist-equal (odo:annotation-plist left)
                      (odo:annotation-plist right))
   (odo:equal-p (odo:expression left)
                (odo:expression right))))

(defmethod odo:scope-by-type (c (type odo:constraint) &key state-space)
  (odo:scope (odo:expression c) :state-space state-space))

(defmethod odo:copy-by-type (c (type odo:constraint) &key context)
  (odo:make-constraint (odo:copy (odo:expression c) :context context)
                       :name (odo:name c)
                       :contingent-p (etypecase (odo:type c)
                                       (odo:contingent-constraint t)
                                       (odo:constraint nil))
                       :annotations (copy-list (odo:annotation-plist c))))

(defmethod utils:print-odo-object-by-type (c (type odo:constraint) stream)
  (utils:odo-print-unreadable-object (c stream)
    (write (class-name (class-of (odo:type c))) :stream stream)
    (write-char #\Space stream)
    (pprint-newline :fill stream)
    (write (odo:name c) :stream stream)
    (write-char #\Space stream)
    (pprint-newline :fill stream)
    (write (odo:expression c) :stream stream)
    (write-char #\Space stream)
    (pprint-newline :fill stream)
    (write :annotations :stream stream)
    (write-char #\Space stream)
    (pprint-newline :fill stream)
    (write (odo:annotation-plist c) :stream stream)))
